package ru.dbotthepony.mc.otm.datagen

import com.google.gson.JsonArray
import com.google.gson.JsonObject
import net.minecraft.core.Direction
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.block.state.properties.Property
import kotlin.math.roundToInt

fun Direction.toYRotBlockstate(): Int {
	return when (this) {
		Direction.DOWN -> 0
		Direction.UP -> 0
		Direction.NORTH -> 0
		Direction.SOUTH -> 180
		Direction.WEST -> -90
		Direction.EAST -> 90
	}
}

fun Direction.toYRotBlockstateInv(): Int {
	return when (this) {
		Direction.DOWN -> 0
		Direction.UP -> 0
		Direction.NORTH -> 180
		Direction.SOUTH -> 0
		Direction.WEST -> 90
		Direction.EAST -> -90
	}
}

fun Direction.toXRotBlockstate(): Int {
	return when (this) {
		Direction.DOWN -> 90
		Direction.UP -> -90
		Direction.NORTH -> 0
		Direction.SOUTH -> 0
		Direction.WEST -> 0
		Direction.EAST -> 0
	}
}

fun Direction.toXRotBlockstateInv(): Int {
	return when (this) {
		Direction.DOWN -> -90
		Direction.UP -> 90
		Direction.NORTH -> 0
		Direction.SOUTH -> 0
		Direction.WEST -> 0
		Direction.EAST -> 0
	}
}

fun <T : Comparable<T>> BlockState.getValueNullable(prop: Property<T>): T? {
	if (hasProperty(prop)) {
		return getValue(prop)
	}

	return null
}
